﻿
I1 i1 = new A();
// Error: Member 'I1.m1()' cannot be accessed with an instance reference; qualify it with a type name instead
// i1.m1();

// Error: A static virtual or abstract interface member can be accessed only on a type parameter.
// I1.m1();

A.m1();

Console.WriteLine();

CallM1(new A());

static void CallM1<T>(T x) where T : I1 {
	T.m1();
}

interface I1 {
	public static abstract void m1();
}

class A : I1 {
	public static void m1() {
		Console.WriteLine("static A.m1");
	}
}