﻿
CallTimes2(new A());

Console.WriteLine();

CallTimes2(new B());

static void CallTimes2<T>(T x) where T : I1<T> {
	Console.WriteLine(T.Times(2));
}

interface I1<TSelf> where TSelf : I1<TSelf> {
	public static abstract int Value { get; }

	public static virtual int Times(int n) {
		Console.WriteLine($"{typeof(I1<TSelf>)}.Times(n: {n}) called");
		return TSelf.Value * n;
	}
}

class A : I1<A> {
	public static int Value { get; } = 5;
}

class B : I1<B> {
	public static int Value { get; } = 11;

	public static int Times(int n) {
		Console.WriteLine($"B.Times(n: {n}) called");
		return Value * n * 1000;
	}
}
